#!/usr/bin/perl -w
############################################################################
##                                                                        ##
##	A Product of CoreUnix.com, Form Submission for CTS1.1             ##
##                                                                        ##
##                                                                        ##
########################## license & copyright header ######################
##                                                                        ##
##    This program has been tested to work both as a CGI script. 	  ##
##                                                                        ##
##                                                                        ##
##                    Copyright (c) 2003 by Sri Penumetcha                ##
##                                                                        ##
##      This program is proprietary software; it is intended only for     ##
##      the  customer's internal use. It is the responsibility of the     ##
##      customer to see to it that it is not used to any illegal          ##
##      cause.  The author has no responsibility what so ever to any      ##
##      damage to property or legal laws caused by this software once     ##
##      it has been out of the authors ownership.                         ##
##                                                                        ##
##      This program is developed in the hope that it will be useful,     ##
##      but WITHOUT ANY WARRANTY; without even the implied warranty of    ##
##      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     ##
##      Agreement.html for more details.                                  ##
##                                                                        ##
##      You should have received a copy of the Agreement.html as well as  ##
##      a copy of License.html with this program, if not, send a request  ##
##      to the below mentioned author(s).                                 ##
##                                                                        ##
##                         CoreUnix.com <srikanth@coreunix.com>           ##
##                                <http://www.coreunix.com/license.html>  ##
##                                                                        ##
######################## end license & copyright header ####################

use strict;
use CGI qw/:standard escapeHTML/;
use CGI::Carp qw/fatalsToBrowser/;
use DBI;
use Fcntl qw/:flock/;
$|++;


############################# Config Start
my $EXEPROG = 'csrtrack.pl';
my $CUSPROG = 'custrack.pl';
my $TITLE = 'Customer Tracking System';
my $COMPANY = 'Customer Tracking System';
my $TOMAIL = 'srikanth@coreunix.com';
my $SENTFROM = 'submit@coreunix.com';
my $ADM_PASS = './password.tech';
my $MAIL_PRG = './custmail.prl';
my $SHOW_CSR = '../showcsr.html';
my $OR_SUMTOP = '../cus_top.html';
my $OR_SUMBOT = '../cus_foot.html';
my $WEB_URL = 'http://www.coreunix.com/custom';
my $CONTCARDS = '/var/www/coreunix.com/custom/contcards';
my $URLREDIRECT = $WEB_URL . '/index.html';
my $SCRIPTURL = $WEB_URL . '/cgi-bin';
my $CCARD_URL = $WEB_URL . '/contcards';
my $UPDATE_URL = $WEB_URL . "/cgi-bin/$CUSPROG?cus_filelnk=";
my $TECH_URL = $WEB_URL . "/cgi-bin/$EXEPROG?action=doview&cus_filelnk=";
my $SORT_URL = $WEB_URL . "/cgi-bin/$EXEPROG?action=sort&sortcrit=";
use constant SHOWNO => 500;
use constant DB => 'dbi:Pg:dbname=CUSCTS';
use constant DBAUTH => 'apache:';
use constant SECRET => 'modperl reigns';
use constant MAX_TRIES => 10;
our ($DBH, $DB_TABLE, $ID_LENGTH);
$ID_LENGTH  =  8;               #length of the session ID.
$DB_TABLE  =  'custrack';                #length of the session ID.
my $DEBUG = 0;

#use lib "/home1/coreunix/www/root/custom/cgi-bin";
use SESS;
############################# Config End

# Open the database
$DBH = DBI->connect(DB, split(':',DBAUTH,2), {PrintError=>0})
        || die "Couldn't open database: ", $DBI::errstr;

# fetch or generate  the session id
my ($session_id, $note) = get_session_id();

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After get_session_id with session_id and note: $session_id--$note\n";
        close(DBUG);
}

# retrieve the state
my $state = get_state($session_id) unless param('clear');

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After get_state with session_id and state: $session_id--$state\n";
        close(DBUG);
}

# reinitialize if we need to
$state  = initialize($state) if !$state->{session_id} or param('restart');

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After initialize with state: $state\n";
        close(DBUG);
}

# Different actions of our page
if( (param('exit') eq 'Exit') || (param('exit') eq '   Exit   ') ) {
		print redirect($URLREDIRECT);
} elsif( param('action') eq 'techview' ) {
		if( usr_check($state)  ) {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		} else {
			tech_page($state);
		}
} elsif( param('action') eq 'doview' ) {
		if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
			tech_view($state);
		} else {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		}
} elsif( param('action') eq 'sort' ) {
		if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
			tech_page($state);
		} else {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		}
} elsif( param('action') eq 'techupdate' ) {
		if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
			tech_update($state);
		} else {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		}
} elsif( param('action') eq 'techsubmit' ) {
	if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
		if( !param('summary') || !param('information') || !param('contact_email') ){
			form_redo(" Please GO BACK and fill in the required fields marked with *");
		} else {
			tech_submit($state);
		}
	} else {
		form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
		"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
	}
} else {
	do_signin($state);
}

# Our Password file Cache

################## Sub Routines Start From HERE #################################

#--------------------------------------------------------------
sub do_signin {
	# This is the Tech Staff's User Login to the Customer
	# Tracking Center.
#--------------------------------------------------------------
	my $state = shift;
	my $tcus_filelnk = param('cus_filelnk');
	my $sessionid = $state->{session_id};
	my @lines;
	

	# Read in file
	open( FILE, "<$SHOW_CSR") or die "Can't open $SHOW_CSR: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@lines = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white', 
			-onLoad => 'if( document.form4 ) document.form4.userid.focus()');
	print_top();
	push(@lines, hidden( -name=>'action', -value=>'techview'));
	push(@lines, hidden( -name=>'cus_filelnk', -value=>'$tcus_filelnk'));
	push(@lines, hidden( -name=>'sessionid', -value=>'$sessionid'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return();
}


#--------------------------------------------------------------
sub tech_page {
	# This is used to display the Customers Pending Requests.
#--------------------------------------------------------------
	# Overwrite our current action so that we save this message
	param('action', 'doview');

	my $state = shift;
	my @lines;
	my $showno = SHOWNO;
	my $tcus_filelnk = param('cus_filelnk');
	my $close = param('close');
	my $prevst = param('prevst');
	my $prevend = param('prevend');
	my $nextst = param('nextst');
	my $nextend = param('nextend');
	$state->{userid} = param('userid');
	$state->{passwd} = param('passwd');
	$_ = $state->{session_id};
	my ($sessionid) = split;
	my $hide = param('hide') || 'unhide';
	my $sortcrit = param('sortcrit');
	if( ! $sortcrit ) { $sortcrit = 'link'; }
	if( ! $prevst ) { $prevst = 0; }
	if( ! $prevend ) { $prevend = ($showno - 1); }
	if( ! $nextst ) { $nextst = $showno; }
	if( ! $nextend ) { $nextend = $nextst + ($showno - 1); }

	# Set the limit and offset values.
	my ($limit, $offset);
	if( param('glide') eq "prev") {
		$limit = (($prevend + 1) - $prevst);
		$offset = $prevst;
	} elsif( param('glide') eq "next" ) {
		$limit = (($nextend + 1) - $nextst);
		$offset = $nextst;
	} else {
		$limit = $showno;
		$offset = 0;
	}

	if( (param('glide') eq "prev") && ($nextst == $showno) ) {
		$prevst = $prevst;
		$prevend = $prevend;
		$nextst = $nextst;
		$nextend = $nextend;
	} elsif( (param('glide') eq "prev") && ($prevst == 0) ) {
		$prevst = $prevst;
		$prevend = $prevend;
		if( $nextst - $showno < 0 ) {
			$nextst = 0;
		} else{ $nextst = $nextst - $showno; }
		if( $nextend - $showno < 0 ) {
			$nextend = 0;
		} else{ $nextend = $nextend - $showno; }
	} elsif( (param('glide') eq "next") && ($nextst == $showno) ) {
		$prevst = $prevst;
		$prevend = $prevend;
		$nextst = $nextst + $showno;
		$nextend = $nextend + $showno;
	} elsif( param('glide') eq "prev") {
		if( $prevst - $showno < 0 ) {
			$prevst = 0;
		} else { $prevst = $prevst - $showno; }
		if( $prevend - $showno < 0 ) {
			$prevend = 0;
		} else { $prevend = $prevend - $showno; }
		if( $nextst - $showno < 0 ) {
			$nextst = 0;
		} else{ $nextst = $nextst - $showno; }
		if( $nextend - $showno < 0 ) {
			$nextend = 0;
		} else{ $nextend = $nextend - $showno; }
	} elsif( param('glide') eq "next" ) {
		$nextst = $nextst + $showno;
		$nextend = $nextend + $showno;
		$prevst = $prevst + $showno;
		$prevend = $prevend + $showno;
	}

	my $sth;
	my $URL_AG = $SORT_URL . "agent" . "&close=no&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend";
	my $URL_LNK = $SORT_URL . "link" . "&close=no&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend";
	my $URL_CUST = $SORT_URL . "custnam" . "&close=no&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend";
	my $URL_STAT = $SORT_URL . "reqstat" . "&close=no&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend";
	my $URL_CLS = $SORT_URL . $sortcrit . "&close=yes&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend&cus_filelnk=";
	my $URL_NEXT = $SORT_URL . $sortcrit . "&close=no&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend&glide=next";
	my $URL_PREV = $SORT_URL . $sortcrit . "&close=no&sessionid=$sessionid&hide=$hide&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend&glide=prev";
	my $SORT_FN = $SORT_URL . $sortcrit . "&close=no&sessionid=$sessionid&prevst=$prevst&prevend=$prevend&nextst=$nextst&nextend=$nextend&hide=";


	
	# Upadate the database to close the case on file tcus_filelnk.
	if( $close eq "yes" ) {
		$sth = $DBH->prepare("UPDATE $DB_TABLE SET req_status = ".
			"'Case Closed' WHERE cus_filelnk='$tcus_filelnk'") or
			die "ERROR: Invalid SQL in do_update(): $!";
		$sth->execute;
	}

		
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "Limit and offset vals: $limit and $offset\n";
        close(DBUG);
}

	# Retrieve the contents of this message
	if( ($sortcrit eq "agent") && ($hide eq "hide") ) {
		$sth = $DBH->prepare("SELECT created, req_status, cus_name, cus_filelnk, " .
				"tech_name FROM $DB_TABLE WHERE usr_passwd is NULL " .
				" AND req_status <> 'Case Closed' ORDER BY tech_name LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "agent") && ($hide eq "unhide") ) {
		$sth = $DBH->prepare("SELECT created, req_status, cus_name, cus_filelnk, " .
				"tech_name FROM $DB_TABLE WHERE usr_passwd is NULL " .
				" ORDER BY tech_name LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "link") && ($hide eq "hide") ) {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is ".
			" NULL AND req_status <> 'Case Closed' ORDER BY created DESC LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "link") && ($hide eq "unhide") ) {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is ".
			" NULL ORDER BY created DESC LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "custnam") && ($hide eq "hide") ) {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is ".
			" NULL AND req_status <> 'Case Closed' ORDER BY cus_name ASC LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "custnam") && ($hide eq "unhide") ) {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is ".
			" NULL ORDER BY cus_name ASC LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "reqstat") && ($hide eq "hide") ) {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is ".
			" NULL AND req_status <> 'Case Closed' ORDER BY req_status ASC LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} elsif( ($sortcrit eq "reqstat") && ($hide eq "unhide") ) {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is ".
			" NULL ORDER BY req_status ASC LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	} else {
		$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is NULL LIMIT $limit OFFSET $offset") or
			die "ERROR: Invalid SQL in tech_page(): $!";
	}
		
	$sth->execute;
	
	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines, 
		qq!<form name=form6 action=$SCRIPTURL/$EXEPROG method=POST>!,
		qq!<CENTER><H3>Administrator Tracking Panel System</H3></CENTER><BR>!,
		qq!<table align="center" width="100%">!,
		qq!<tbody><tr><td> Shows $showno items at a time. </td><td></td>!,
		qq!<td><A HREF="$URL_PREV"> << Prev</A> <B> | </B> <A HREF="$URL_NEXT">Next >> </A></td></tr></tbody></table>!,
		qq!<table bgcolor="#cccccc" align="center" width="100%">!,
		qq!<tbody><tr><td><img src="../images/bigred.png" alt="Red Button" width=30 height=30 border=0>!,
		qq!<b>Case Closed</b></td>!,
		qq!<td><img src="../images/bigyellow.png" alt="Yellow Button" width=30 height=30 border=0>!,
		qq!<b>Waiting on Customer</b></td><td>!,
		qq!<img src="../images/biggreen.png" alt="Green Button" width=30 height=30  border=0>!,
		qq!<b>Waiting on Tech</b></td></tr><tr></tr></tbody></table>!,
		qq!<BR><HR SIZE="1" NOSHADE>!,
		qq!<table align="center" width="100%"><tbody>!,
		qq!<tr><td><B>Status</B><A HREF="$URL_STAT">(sort)</A></td><td>!,
		qq!<B>Customer Name</B><A HREF="$URL_CUST">(sort)</A></td><td><B>Request Link</B>!,
		qq!</td>!,
		qq!<td><B>Submitted</B><A HREF="$URL_LNK">(sort)</A></td><td align="left"><B>Agent</B><A HREF="$URL_AG">(sort)</A></td></tr>!);
	
	my ($imagepic, $altcolor);
	my %mnths = ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar', '04' => 'Apr',
		'05' => 'May', '06' => 'Jun', '07' => 'Jul', '08' => 'Aug',
		'09' => 'Sep', '10' => 'Oct', '11' => 'Nov', '12' => 'Dec');

	while( my $cusref = $sth->fetchrow_hashref) {
		my $closeflag = 0;
		if( $altcolor =~ /white/ ) {
			$altcolor = "#CCFFFF";
		} elsif( $altcolor =~ /#CCFFFF/) {
			$altcolor = "white";
		} else {
			$altcolor = "white";
		}
		if( $cusref->{req_status} =~ /Waiting on ToChk/ ) {
			$imagepic = "../images/dotgreen.png";
		} elsif ( $cusref->{req_status} =~ /Waiting on Tech/ ) {
			$imagepic = "../images/dotgreen.png";
		} elsif ( $cusref->{req_status} =~ /Waiting on Customer/ ) {
			$imagepic = "../images/dotyellow.png";
		} elsif ( $cusref->{req_status} =~ /Case Closed/ ) {
			$imagepic = "../images/dotred.png";
			$closeflag = 1;
		} else {
			$imagepic = "";
		}
		my ($day, $time) = split(/ /, $cusref->{created});
		my ($tyear, $tmonth, $tday) = split(/-/, $day);
		$day = "$mnths{$tmonth} $tday $tyear";
		$time =~ s/\.[0-9]*$//;
		$day .= " $time";

		if( $closeflag ) {
		  push(@lines,
			qq!<tr bgcolor="$altcolor"><td>!,
			qq!<img src="$imagepic" alt="Ask Tech" width=20 height=20 border=0></td>!,
			qq!<td>$cusref->{cus_name}</td><td>!,
			qq!<A HREF="$TECH_URL$cusref->{cus_filelnk}&email=$state->{userid}&sessionid=$sessionid">!,
			qq!$cusref->{cus_filelnk}</A>!,
			qq!</td><td>$day</td><td align="left">$cusref->{tech_name}</td></tr>!);
		} else {
		  push(@lines,
			qq!<tr bgcolor="$altcolor"><td>!,
			qq!<img src="$imagepic" alt="Ask Tech" width=20 height=20 border=0></td>!,
			qq!<td>$cusref->{cus_name}</td><td>!,
			qq!<A HREF="$TECH_URL$cusref->{cus_filelnk}&email=$state->{userid}&sessionid=$sessionid">!,
			qq!$cusref->{cus_filelnk}</A><B> ( <font color="RED"> close case !,
			qq!</font><A HREF="$URL_CLS$cusref->{cus_filelnk}"> X </A></B><B> ) </B>!,
			qq!</td><td>$day</td><td align="left">$cusref->{tech_name}</td></tr>!);
		}
			
	}

	if( $hide eq "hide" ) {
		$SORT_FN .= "unhide";
		push(@lines,
			qq!<tr bgcolor="white"><td><A HREF="$SORT_FN">View Closed</A></td>!,
			qq!<td></td><td></td><td></td><td></td></tr>!);
	} else {
		$SORT_FN .= "hide";
		push(@lines,
			qq!<tr bgcolor="white"><td><A HREF="$SORT_FN">Hide Closed</A></td>!,
			qq!<td></td><td></td><td></td><td></td></tr>!);
	}
	push(@lines,qq!</tbody></table>!);
	push(@lines, 
		qq!<BR>!,
		qq!<center><input type="submit" name="update" value="Proceed To Emailed Incident">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<BR>!);
	push(@lines, hidden( -name=>'showno', -value=>'$showno'));
	push(@lines, hidden( -name=>'action', -value=>'doview'));
	push(@lines, hidden( -name=>'cus_filelnk', -value=>'$tcus_filelnk'));
	push(@lines, hidden( -name=>'sessionid', -value=>'$sessionid'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return();
}

#--------------------------------------------------------------
sub usr_check {
	# This is used to Update the Tech's Passwords Cache.
#--------------------------------------------------------------
	my $state = shift;
	$state->{userid} = param('userid');
	$state->{passwd} = param('passwd');

	open(FILE, $ADM_PASS) or die "Cannot open file $ADM_PASS: $!\n";
	flock(FILE, LOCK_SH); # Exclusive lock for reading
	while ( <FILE> ) {
		my ($usrdat, $passdat) = split;
		if( ($state->{userid} eq $usrdat) && ($state->{passwd} eq $passdat) ){
			save_state($state, $state->{session_id});
			flock(FILE, LOCK_UN);
			close FILE;
			return(0);
		} 
	}
	flock(FILE, LOCK_UN);
	close FILE;

	return(1);
}

#--------------------------------------------------------------
sub tech_view {
	# This is the Tech Staff's Customer Request Form.
#--------------------------------------------------------------
	my $state = shift;
	my $tcus_filelnk = param('cus_filelnk');
	my  @lines;
	param('action', 'techupdate');
	
	# Retrieve the contents of this message
	my $sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE cus_filelnk='$tcus_filelnk'") or
		 die "ERROR: Invalid SQL in do_view(): $!";
		
	$sth->execute;
	
	my ($cus_ticket, $created, $cus_name, $cus_email, $tech_name, $tech_email,
		$req_status, $req_message, $sub_title, $cus_filelnk, $message ) = $sth->fetchrow;

	open(FILE, "$CONTCARDS/$tcus_filelnk") or die "Cannot open $tcus_filelnk:$!\n";
	flock(FILE, LOCK_SH);
	my @data = (<FILE>);
	flock(FILE, LOCK_UN);
	close FILE;
	
	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines, qq!<form name=form7 action=$SCRIPTURL/$EXEPROG method=POST >!);
	push(@lines,
		qq!<center><input type="submit" name="update" value="Update">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<HR SIZE="1" NOSHADE>!);
	push(@lines, @data);
	push(@lines, hidden( -name=>'action', -value=>'techupdate'));
	push(@lines, hidden( -name=>'sessionid', -value=>'$sessionid'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return();
}

#--------------------------------------------------------------
sub tech_update {
	# This is Tech Staff's Request Update form.
#--------------------------------------------------------------
	my $state = shift;
	my $tcus_filelnk = param('cus_filelnk');
	my $email = $state->{userid};
	my  @lines;
	param('action', 'techsubmit');

	open(FILE, "$CONTCARDS/$tcus_filelnk") or die "Cannot open $tcus_filelnk:$!\n";
	flock(FILE, LOCK_SH);
	my @data = (<FILE>);
	flock(FILE, LOCK_UN);
	close FILE;

	# Retrieve the contents of this message
	my $sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE cus_filelnk='$tcus_filelnk'") or
		 die "ERROR: Invalid SQL in tech_update(): $!";
		
	$sth->execute;
	
	my ($cus_ticket, $created, $cus_name, $cus_email, $tech_name, $tech_email,
		$req_status, $req_message, $sub_title, $cus_filelnk, $message ) = $sth->fetchrow;

	$email =~ /^([a-zA-Z0-9_]+)/; 
	$tech_name =  $&;

	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines, qq!<form name=form8 action=$SCRIPTURL/$EXEPROG method=POST>!);
	push(@lines, qq!<TABLE BORDER=0>!);
	push(@lines,
	hidden('email'),
	hidden(-name=>"req_status", -value=>"$req_status"),
	hidden( -name=>"cus_email", -value=>"$cus_email"),
	hidden( -name=>"tech_name", -value=>"$tech_name"),
	qq!<TR bgcolor="#cccccc"><TD colspan="2"><b>Update Information</b></TD></TR>!,
	qq!<TR><TD width="20%"><div color="#666666"><span style="color:#990000;">*</span>!,
	qq!Subject:</div></TD>!,
	qq!<TD width="80%"><input type="text" name="summary" size="30" value="$sub_title" maxlength="80">!,
	qq!</TD></TR>!,
	qq!<TR><TD width="20%" valign="top"><div color="#666666">!,
	qq!<span style="color:#990000;">*</span>Comments:!,
	qq!<br>(<em>2000 characters</em>)</div></TD>!,
	qq!<TD width="80%">!,
	qq!<textarea name="information" cols="80" rows="10" wrap="hard"></textarea>!,
	qq!</TD></TR>!,
	qq!<TR bgcolor="#cccccc"><TD colspan="2"><b>Contact Information</b> (Optional)</TD></TR>!,
	qq!<TR background-color="#eeeeee"><TD width="20%"><div color="#666666">Name:</div></TD>!,
	qq!<TD width="80%">$tech_name</TD></TR>!,
	qq!<TR background-color="#eeeeee"><TD width="20%"><div color="#666666">!,
	qq!<span style="color:#990000;">*</span>Email:</div></TD>!,
	qq!<TD width="80%">!,
	qq!<input type="text" name="contact_email" value="$email" size=40 maxlength=50></TD></TR>!);
	push(@lines,qq!</TABLE>!);
	push(@lines,
		qq!<HR SIZE="1" NOSHADE>!,
		qq!<center><input type="submit" name="submit" value="Submit">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="reset" value="Clear">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<HR SIZE="1" NOSHADE>!);
	push(@lines, @data);
	push(@lines, hidden( -name=>'action', -value=>'techsubmit'));
	push(@lines, hidden( -name=>'sessionid', -value=>'$sessionid'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return ();
}

#--------------------------------------------------------------
sub tech_submit {
	# This the Tech Staff's form after Request Submittal.
#--------------------------------------------------------------
	my $tcus_filelnk = param('cus_filelnk');
	my $summary = param('summary');
	my $information = param('information');
	my $contact_email = param('contact_email');
	my $cus_email = param('cus_email');
	my $tech_name = param('tech_name');
	my $req_status = param('req_status');
	my $time = localtime();
	my @tlines;
	my  @lines;
	
	# information to be mailed
	my $m_information = $information;

	# Deal with line breaks
	$information = escapeHTML($information);
	$information =~ s/(?:\015=012?|\012)/<BR>/g;

	open(FILE, "$CONTCARDS/$tcus_filelnk") or die "Cannot open $tcus_filelnk:$!\n";
	flock(FILE, LOCK_SH);
	my @data = (<FILE>);
	flock(FILE, LOCK_UN);
	close FILE;


	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines,
		qq!<form name=form9 action=$SCRIPTURL/$EXEPROG method=POST>!,
		qq!<center><input type="submit" name="update" value="Update">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<HR SIZE="1" NOSHADE>!);
	push(@lines, 
		hidden('email'));
	push(@tlines, qq!<TABLE border="0" width="98%" cellspacing="0" cellpadding="8">!);
	push(@tlines, qq!<TR bgcolor="#cccccc"><TD width="19%">!,
		qq!<div align="center">$time</div></TD>!,
		qq!<TD width="48%"><B>Customer Notified with Email</B></TD>!,
		qq!<TD width="33%"><div align="center">$tech_name($COMPANY)</div></TD></TR>!,
		qq!<TR bgcolor="#efefef"><TD width="19%">!,
		qq!<div align="center">Agent Response:</div></TD>!,
		qq!<TD colspan="2"><div align="left">$information</div></TD></TR>!);
	push(@tlines, qq!</TABLE>!);
	push(@tlines,qq!<HR SIZE="1" NOSHADE>!);
	push(@tlines, @data);

	open(FILE, ">$CONTCARDS/$tcus_filelnk") or die "Cannot open file $tcus_filelnk:$!\n";
	flock(FILE, LOCK_EX);	#Exlusive Lock for writing
	print FILE @tlines;
	flock(FILE, LOCK_UN);
	close FILE;
	
	push(@lines, @tlines);
	push(@lines,qq!</form>!);
	print_form(\@lines);

	my $sth = $DBH->prepare("UPDATE $DB_TABLE SET req_status = ".
			 "'Waiting on Customer', sub_title = '$summary',  tech_name = '$tech_name', ".
			"tech_email = '$contact_email' WHERE cus_filelnk='$tcus_filelnk'") or
			 die "ERROR: Invalid SQL in do_update(): $!";
	$sth->execute;

	# Retrieve the contents of this message
	$sth = $DBH->prepare("SELECT * FROM $DB_TABLE ".
		" WHERE cus_filelnk='$tcus_filelnk'") or
		 die "ERROR: Invalid SQL in tech_update(): $!";
		
	$sth->execute;
	my $userid;
	while( my $cusref = $sth->fetchrow_hashref) {
		if( $cusref->{cus_userid} ) {
			$userid = $cusref->{cus_userid};
		}
	}

	# Message
	my $subject = $tcus_filelnk;
	$subject =~ s/.html//;
	$summary = $summary . "(Request ID:$subject)";
	$summary =~ s/[\047]/:QUOTE:/g;		# for handling (') on command line

	my $pcard_url = $CCARD_URL . '/' . $tcus_filelnk;
	my $update_url;
	$update_url = $UPDATE_URL . $tcus_filelnk;
	my $rcpt_message = "$tech_name(Customer Service Rep.) Response:\n $m_information \n\n";
	$rcpt_message .= "Note: Please do not reply to this email \n" .
		"To View or Submit your requests, please click on the link below: ";
	$rcpt_message .= "$update_url\n\n";
	$rcpt_message =~ s/[\047]/:QUOTE:/g;		# for handling (') on command line

	# Send mail to Customer  with 
	# to:$email from:$tech_email subject:$summary  Message:$information
	system("$MAIL_PRG '$cus_email' '$SENTFROM' '$summary' '$rcpt_message' &");

	return ();
}

#--------------------------------------------------------------
sub print_top {
	# This prints out the @lines as a web page.
#--------------------------------------------------------------
	my @data;

	open( FILE, "< $OR_SUMTOP") or die "Can't open $OR_SUMTOP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
}

#--------------------------------------------------------------
sub print_form {
	# This prints out the @lines as a web page.
#--------------------------------------------------------------
	my @data;

	# Send our collected output to the user and end our HTML
	my  $lines = shift;
	print join("\n", @$lines);

	# Print footer and end page
	open( FILE, "< $OR_SUMBOT") or die "Can't open $OR_SUMBOT: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
	print end_html;

	return ();
}

#--------------------------------------------------------------
sub form_redo {
#--------------------------------------------------------------
	my ($errMsg) = @_;
	my @data;
	open( FILE, "< $OR_SUMTOP") or die "Can't open $OR_SUMTOP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	print header;
	foreach  ( @data ) {
		print;
	}

	print "<BR>";
	print "<BR>";
	print "<STRONG><font color=#FF0033>SORRY !!! " .
		"$errMsg</font></STRONG>\n";
	print "<BR>";
	print "<BR>";

	open( FILE, "< $OR_SUMBOT") or die "Can't open $OR_SUMBOT: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
	print end_html;
}
############################################ THE END  ##########################################
