#!/usr/bin/perl -w
############################################################################
##                                                                        ##
##	A Product of CoreUnix.com, Form Submission for CTS1.1             ##
##                                                                        ##
##                                                                        ##
########################## license & copyright header ######################
##                                                                        ##
##    This program has been tested to work both as a CGI script. 	  ##
##                                                                        ##
##                                                                        ##
##                    Copyright (c) 2003 by Sri Penumetcha                ##
##                                                                        ##
##      This program is proprietary software; it is intended only for     ##
##      the  customer's internal use. It is the responsibility of the     ##
##      customer to see to it that it is not used to any illegal          ##
##      cause.  The author has no responsibility what so ever to any      ##
##      damage to property or legal laws caused by this software once     ##
##      it has been out of the authors ownership.                         ##
##                                                                        ##
##      This program is developed in the hope that it will be useful,     ##
##      but WITHOUT ANY WARRANTY; without even the implied warranty of    ##
##      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     ##
##      Agreement.html for more details.                                  ##
##                                                                        ##
##      You should have received a copy of the Agreement.html as well as  ##
##      a copy of License.html with this program, if not, send a request  ##
##      to the below mentioned author(s).                                 ##
##                                                                        ##
##                         CoreUnix.com <srikanth@coreunix.com>           ##
##                              <http://www.coreunix.com/license.html>    ##
##                                                                        ##
######################## end license & copyright header ####################

use strict;
use CGI qw/:standard escapeHTML/;
use CGI::Carp qw/fatalsToBrowser/;
use DBI;
use Fcntl qw/:flock/;
$|++;


############################# Config Start
my $EXEPROG = 'custrack.pl';
my $CSRPROG = 'csrtrack.pl';
my $TITLE = 'Customer Tracking System';
my $COMPANY = 'Customer Tracking System';
my $TOMAIL = 'srikanth@coreunix.com';
my $SENTFROM = 'submit@coreunix.com';
my $MAIL_PRG = './custmail.prl';
my $SHOW_CUS = '../showcus.html';
my $OR_SUMTOP = '../cus_top.html';
my $OR_SUMBOT = '../cus_foot.html';
my $WEB_URL = 'http://www.coreunix.com/custom';
my $CONTCARDS = '/var/www/coreunix.com/custom/contcards';
my $URLREDIRECT = $WEB_URL . '/index.html';
my $SCRIPTURL = $WEB_URL . '/cgi-bin';
my $CCARD_URL = $WEB_URL . '/contcards';
my $UPDATE_URL = $WEB_URL . "/cgi-bin/$EXEPROG?action=doview&cus_filelnk=";
my $TECH_URL = $WEB_URL . "/cgi-bin/$CSRPROG?cus_filelnk=";
use constant DB => 'dbi:Pg:dbname=CUSCTS';
use constant DBAUTH => 'apache:';
use constant SECRET => 'modperl reigns';
use constant MAX_TRIES => 10;
our ($DBH, $DB_TABLE, $ID_LENGTH);
$ID_LENGTH  =  8;               #length of the session ID.
$DB_TABLE  =  'custrack';                #length of the session ID.
my $DEBUG = 0;

#use lib "/home1/coreunix/www/root/custom/cgi-bin";
use SESS;
############################# Config End

# Open the database
$DBH = DBI->connect(DB, split(':',DBAUTH,2), {PrintError=>0})
        || die "Couldn't open database: ", $DBI::errstr;

# fetch or generate  the session id
my ($session_id, $note) = get_session_id();

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After get_session_id with session_id and note: $session_id--$note\n";
        close(DBUG);
}

# retrieve the state
my $state = get_state($session_id) unless param('clear');

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After get_state with session_id and state: $session_id--$state\n";
        close(DBUG);
}

# reinitialize if we need to
$state  = initialize($state) if !$state->{session_id} or param('restart');

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After initialize with state: $state\n";
        close(DBUG);
}

# Different actions of our page
if( (param('exit') eq 'Exit') || (param('exit') eq '   Exit   ') ) {
		print redirect($URLREDIRECT);
} elsif( param('action') eq 'custview' ) {
		if( usr_check($state)  ) {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		} else {
			cust_page($state);
		}
} elsif( param('action') eq 'doview' ) {
		if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
			do_view($state);
		} else {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		}
} elsif( param('action') eq 'update' ) {
		if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
			do_update($state);
		} else {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		}
} elsif( param('action') eq 'submit' ) {
		if( $state->{session_id} && $state->{userid} && $state->{passwd} ) {
			do_submit($state);
		} else {
			form_redo("<BR> Your User-ID or Password does not exist.<BR>&nbsp;&nbsp;".
			"&nbsp Please go 'Back' to enter the correct User-ID OR Password."); 
		}
} else {
	do_signin($state);
}

################## Sub Routines Start From HERE #################################

#--------------------------------------------------------------
sub cust_page {
	# This is used to display the Customers running Requests.
#--------------------------------------------------------------
	my $state = shift;
	# Overwrite our current action so that we save this message
	param('action', 'doview');

	my $tcus_filelnk = param('cus_filelnk');
	my @lines;
	my $sth;

	# Retrieve the contents of this message
	$sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE cus_userid='$state->{userid}' ".
		"AND usr_passwd is NULL") or
		die "ERROR: Invalid SQL in do_update(): $!";
		
	$sth->execute;
	
	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines, 
		qq!<form name=form6 action=$SCRIPTURL/$EXEPROG method=POST>!,
		hidden('action'),
		hidden( -name=>"cus_filelnk", -value=>"$tcus_filelnk"),
		qq!<CENTER><H2>Customer Request Manager</H2></CENTER><BR>!,
		qq!<center><input type="submit" name="update" value="Proceed To Emailed Incident">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center><BR>!,
		qq!<table bgcolor="#cccccc" align="center" width="100%">!,
		qq!<tbody><tr><td colspan="4"><b>Open Requests:</b></td></tr>!,
		qq!<tr><td width="20%"><b>Status</b></td>!,
		qq!<td align="left" width="30%"><b>Request Summary</b></td><td align="left" width="20%">!,
		qq!<b>Request ID</b></td><td align="left" width="15%"><b>Submitted</b></td><td  width="15%">!,
		qq!<b>Agent</b></td></tr></tbody></table>!,
		qq!<HR SIZE="1" NOSHADE>!,
		qq!<table align="center" width="100%"><tbody>!);
	
	my ($stattext, $altcolor);
	my %mnths = ( '01' => 'Jan', '02' => 'Feb', '03' => 'Mar', '04' => 'Apr',
		'05' => 'May', '06' => 'Jun', '07' => 'Jul', '08' => 'Aug',
		'09' => 'Sep', '10' => 'Oct', '11' => 'Nov', '12' => 'Dec');

	while( my $cusref = $sth->fetchrow_hashref) {
		if( $altcolor =~ /white/ ) {
			$altcolor = "#CCFFFF";
		} elsif( $altcolor =~ /#CCFFFF/) {
			$altcolor = "white";
		} else {
			$altcolor = "white";
		}
		if( $cusref->{req_status} =~ /Waiting on ToChk/ ) {
			$stattext = "Waiting on ToChk";
		} elsif ( $cusref->{req_status} =~ /Waiting on Tech/ ) {
			$stattext = "Waiting on Agent";
		} elsif ( $cusref->{req_status} =~ /Waiting on Customer/ ) {
			$stattext = "Waiting on Customer";
		} else {
			$stattext = "";
		}
		my $req_id = $cusref->{cus_filelnk};
		$req_id =~ s/.html//;

		my ($day, $time) = split(/ /, $cusref->{created});
		my ($tyear, $tmonth, $tday) = split(/-/, $day);
		$day = "$mnths{$tmonth} $tday $tyear";
		$time =~ s/\.[0-9]*$//;
		$day .= " $time";

		push(@lines,
			qq!<tr bgcolor="$altcolor"><td width="20%">$stattext</td>!,
			qq!<td align="left" width="30%">$cusref->{sub_title}</td><td align="left" width="20%">!,
			qq!<A HREF="$UPDATE_URL$cusref->{cus_filelnk}&userid=$state->{userid}&sessionid=$state->{session_id}">!,
			qq!$req_id</A></td><td align="left" width="15%">$day</td><td width="15%">$cusref->{tech_name}</td></tr>!);
	}

	push(@lines,qq!</tbody></table><BR>!);
	push(@lines, hidden( -name=>'action', -value=>'doview'));
	push(@lines, hidden( -name=>'cus_filelnk', -value=>'$tcus_filelnk'));
	push(@lines, hidden( -name=>'sessionid', -value=>'$sessionid'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return();
}

#--------------------------------------------------------------
sub do_view {
	# This fuction is shows the selected record.
#--------------------------------------------------------------
	my $state = shift;
	my $tcus_filelnk = param('cus_filelnk');
	my  @lines;

	
	# Overwrite our current action so that we save this message
	param('action', 'update');

	# Retrieve the contents of this message
	my $sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE cus_filelnk='$tcus_filelnk'") or
		 die "ERROR: Invalid SQL in do_view(): $!";
	$sth->execute;
	
	my ($cus_ticket, $created, $cus_name, $cus_email, $tech_name, $tech_email,
		$req_status, $req_message, $sub_title, $cus_filelnk, $message ) = $sth->fetchrow;

	open(FILE, "$CONTCARDS/$tcus_filelnk") or die "Cannot open $tcus_filelnk:$!\n";
	flock(FILE, LOCK_SH);
	my @data = (<FILE>);
	flock(FILE, LOCK_UN);
	close FILE;
	
	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;

	push(@lines, qq!<form name=form1 action=$SCRIPTURL/$EXEPROG method=POST >!);
	push(@lines,
		hidden('action'),
		hidden( -name=>'sessionid', -value=>'$state->{session_id}'),
		qq!<center><input type="submit" name="update" value="Update">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<HR SIZE="1" NOSHADE>!);
	push(@lines, @data);
	push(@lines,qq!</form>!);
	
	print_form(\@lines);
	return();
}

#--------------------------------------------------------------
sub do_update {
	# This is allows the Customer To Submit Data.
#--------------------------------------------------------------
	my $state = shift;
	my $tcus_filelnk = param('cus_filelnk');
	my  @lines;

	# Overwrite our current action so that we save this message
	param('action', 'submit');

	open(FILE, "$CONTCARDS/$tcus_filelnk") or die "Cannot open $tcus_filelnk:$!\n";
	flock(FILE, LOCK_SH);
	my @data = (<FILE>);
	flock(FILE, LOCK_UN);
	close FILE;

	# Retrieve the contents of this message
	my $sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE cus_filelnk='$tcus_filelnk'") or
		 die "ERROR: Invalid SQL in do_update(): $!";
		
	$sth->execute;
	
	my ($cus_ticket, $created, $cus_name, $cus_email, $tech_name, $tech_email,
		$req_status, $req_message, $sub_title, $cus_filelnk, $message ) = $sth->fetchrow;

	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines, qq!<form name=form2 action=$SCRIPTURL/$EXEPROG method=POST>!);
	push(@lines, qq!<TABLE BORDER=0>!);
	push(@lines,
	hidden('action'),
	hidden(-name=>"req_status", -value=>"$req_status"),
	hidden( -name=>"cus_name", -value=>"$cus_name"),
	hidden( -name=>'sessionid', -value=>'$state->{session_id}'),
	qq!<TR bgcolor="#cccccc"><TD colspan="2"><b>Update Information</b></TD></TR>!,
	qq!<TR><TD width="20%"><div color="#666666"><span style="color:#990000;">*</span>!,
	qq!Subject:</div></TD>!,
	qq!<TD width="80%"><input type="text" name="summary" size="30" value="" maxlength="80">!,
	qq!</TD></TR>!,
	qq!<TR><TD width="20%" valign="top"><div color="#666666">!,
	qq!<span style="color:#990000;">*</span>Comments:!,
	qq!<br>(<em>2000 characters</em>)</div></TD>!,
	qq!<TD width="80%">!,
	qq!<textarea name="information" cols="80" rows="10" wrap="hard"></textarea>!,
	qq!</TD></TR>!,
	qq!<TR bgcolor="#cccccc"><TD colspan="2"><b>Contact Information</b> (Optional)</TD></TR>!,
	qq!<TR background-color="#eeeeee"><TD width="20%"><div color="#666666">Name:</div></TD>!,
	qq!<TD width="80%">$cus_name</TD></TR>!,
	qq!<TR background-color="#eeeeee"><TD width="20%"><div color="#666666">!,
	qq!<span style="color:#990000;">*</span>Email:</div></TD>!,
	qq!<TD width="80%">!,
	qq!<input type="text" name="contact_email" value="$cus_email" size=40 maxlength=50></TD></TR>!);
	push(@lines,qq!</TABLE>!);
	push(@lines,
		qq!<HR SIZE="1" NOSHADE>!,
		qq!<center><input type="submit" name="submit" value="Submit">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="reset" value="Clear">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<HR SIZE="1" NOSHADE>!);
	push(@lines, @data);
	push(@lines,qq!</form>!);
	
	print_form(\@lines);
	return ();
}

#--------------------------------------------------------------
sub do_submit {
	# This is displayed after the Customer Submits his Request.
#--------------------------------------------------------------
	# Overwrite our current action so that we save this message
	my $state = shift;
	param('action', 'update');

	my $tcus_filelnk = param('cus_filelnk');
	my $summary = param('summary');
	my $contact_email = param('contact_email');
	my $cus_name = param('cus_name');
	my $req_status = param('req_status');
	my $information = param('information');
	my $time = localtime();
	my @tlines;
	my  @lines;

	# If no summary exists means that a user just submitted his info
	if( !$summary ) { $summary ='Details Submitted'};
	# information to mail
	my $m_information = $information;

	# Deal with line breaks
	$information = escapeHTML($information);
	$information =~ s/(?:\015=012?|\012)/<BR>/g;
	
	open(FILE, "$CONTCARDS/$tcus_filelnk") or die "Cannot open $tcus_filelnk:$!\n";
	flock(FILE, LOCK_SH);
	my @data = (<FILE>);
	flock(FILE, LOCK_UN);
	close FILE;


	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	push(@lines,
		qq!<form name=form3 action=$SCRIPTURL/$EXEPROG method=POST>!,
		qq!<center><input type="submit" name="update" value="Update">!,
		qq!&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp!,
		qq!<input type="submit" name="exit" value="Exit"></center>!,
		qq!<HR SIZE="1" NOSHADE>!);
	push(@lines, 
		hidden('action'),
		hidden( -name=>'sessionid', -value=>'$state->{session_id}'));
	push(@tlines, qq!<TABLE border="0" width="98%" cellspacing="0" cellpadding="8">!);
	push(@tlines, qq!<TR bgcolor="#cccccc"><TD width="19%">!,
		qq!<div align="center">$time</div></TD>!,
		qq!<TD width="48%"><B>Request Updated</B></TD>!,
		qq!<TD width="33%"><div align="center">$cus_name</div></TD></TR>!,
		qq!<TR bgcolor="#efefef"><TD width="19%">!,
		qq!<div align="center">Customer Request:</div></TD>!,
		qq!<TD colspan="2"><div align="left">$information</div></TD></TR>!);
	push(@tlines, qq!</TABLE>!);
	push(@tlines,qq!<HR SIZE="1" NOSHADE>!);
	push(@tlines, @data);

	open(FILE, ">$CONTCARDS/$tcus_filelnk") or die "Cannot open file $tcus_filelnk:$!\n";
	flock(FILE, LOCK_EX);	#Exlusive Lock for writing
	print FILE @tlines;
	flock(FILE, LOCK_UN);
	close FILE;
	
	push(@lines, @tlines);
	push(@lines,qq!</form>!);

	print_form(\@lines);

	my $sth = $DBH->prepare("UPDATE $DB_TABLE SET req_status = ".
			 "'Waiting on Tech', sub_title = '$summary' WHERE cus_filelnk='$tcus_filelnk'") or
			 die "ERROR: Invalid SQL in do_update(): $!";
	$sth->execute;

	# Summary with Request ID added
	my $subject = $tcus_filelnk;
	$subject =~ s/.html//;
	$summary = $summary . "(Request ID:$subject)";
	$summary =~ s/[\047]/:QUOTE:/g;		# for handling (') on command line

	# Message to Customer
	my $pcard_url = $CCARD_URL . '/' . $tcus_filelnk;
	my $update_url;

	$update_url = $UPDATE_URL . $tcus_filelnk;
		
	my $rcpt_message .= "\nNote: Please do not reply to this email \n" .
		"To View or Submit your requests, please click on the link below: ";
	$rcpt_message .= "$update_url\n\n";
	$rcpt_message .= "Customer Message:\n $m_information \n ";
	$rcpt_message =~ s/[\047]/:QUOTE:/g;		# for handling (') on command line

	# Send mail user with to:$email from:$tech_email subject:$summary  Message:$information
	system("$MAIL_PRG '$contact_email' '$SENTFROM' '$summary' '$rcpt_message' &");

	# Message to Tech Staff.
	$update_url = $TECH_URL . $tcus_filelnk;
	my $tech_message = "$cus_name ($contact_email) " .
				"has submitted an online " .
				"form.\n";
	$tech_message .= "The form may be found at: ";
	$tech_message .= "$pcard_url\n\n";
	$tech_message .= "Requests may be Viewed and Submitted at: ";
	$tech_message .= "$update_url\n\n";
	$tech_message .= "Customer Message:\n $m_information \n ";
	$tech_message =~ s/[\047]/:QUOTE:/g;		# for handling (') on command line
	
	# Send mail TECH
	system("$MAIL_PRG '$TOMAIL' '$SENTFROM' '$summary' '$tech_message' &");

	return ();
}

#--------------------------------------------------------------
sub do_signin {
	# This is the Tech Staff's User Login to the Customer
	# Tracking Center.
#--------------------------------------------------------------
	my $state = shift;
	my $sessionid = $state->{session_id};
	my $tcus_filelnk = param('cus_filelnk');
	my @lines;

	# Read in file
	open( FILE, "<$SHOW_CUS") or die "Can't open $SHOW_CUS: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@lines = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white', 
			-onLoad => 'if( document.form4 ) document.form4.userid.focus()');
	print_top();
	push(@lines, hidden( -name=>'action', -value=>'custview'));
	push(@lines, hidden( -name=>'cus_filelnk', -value=>'$tcus_filelnk'));
	push(@lines, hidden( -name=>'sessionid', -value=>'$sessionid'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return();
}

#--------------------------------------------------------------
sub print_top {
	# This prints out the @lines as a web page.
#--------------------------------------------------------------
	my @data;

	open( FILE, "< $OR_SUMTOP") or die "Can't open $OR_SUMTOP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
}

#--------------------------------------------------------------
sub print_form {
	# This prints out the @lines as a web page.
#--------------------------------------------------------------
	my @data;

	# Send our collected output to the user and end our HTML
	my  $lines = shift;
	print join("\n", @$lines);

	# Print footer and end page
	open( FILE, "< $OR_SUMBOT") or die "Can't open $OR_SUMBOT: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
	print end_html;

	return ();
}

#--------------------------------------------------------------
sub form_redo {
#--------------------------------------------------------------
	my ($errMsg) = @_;
	my @data;
	open( FILE, "< $OR_SUMTOP") or die "Can't open $OR_SUMTOP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	print header;
	foreach  ( @data ) {
		print;
	}

	print "<BR>";
	print "<BR>";
	print "<STRONG><font color=#FF0033>SORRY !!! " .
		"$errMsg</font></STRONG>\n";
	print "<BR>";
	print "<BR>";

	open( FILE, "< $OR_SUMBOT") or die "Can't open $OR_SUMBOT: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
	print end_html;
}

#--------------------------------------------------------------
sub usr_check {
	# This checks whether user registered or not.
#--------------------------------------------------------------
	my $state = shift;
	$state->{userid} = param('userid');
	$state->{passwd} = param('passwd');

	my $sth = $DBH->prepare("SELECT usr_passwd, cus_userid  FROM $DB_TABLE WHERE ".
			"cus_userid='$state->{userid}' AND  usr_passwd is NOT NULL") or 
				die "ERROR: Invalid SQL in do_update(): $!";
	$sth->execute;
	
	my ($usr_passwd, $cus_userid) = $sth->fetchrow;

	if( ($state->{userid} eq $cus_userid) && ($state->{passwd} eq $usr_passwd) ){
		save_state($state, $state->{session_id});
		return(0);
	} 
	return(1);
}
############################################ THE END  ##########################################
