#!/usr/bin/perl -w
############################################################################
##                                                                        ##
##	A Product of CoreUnix.com, Form Submission for CTS1.1             ##
##                                                                        ##
##                                                                        ##
########################## license & copyright header ######################
##                                                                        ##
##    This program has been tested to work both as a CGI script. 	  ##
##                                                                        ##
##                                                                        ##
##                    Copyright (c) 2003 by Sri Penumetcha                ##
##                                                                        ##
##      This program is proprietary software; it is intended only for     ##
##      the  customer's internal use. It is the responsibility of the     ##
##      customer to see to it that it is not used to any illegal          ##
##      cause.  The author has no responsibility what so ever to any      ##
##      damage to property or legal laws caused by this software once     ##
##      it has been out of the authors ownership.                         ##
##                                                                        ##
##      This program is developed in the hope that it will be useful,     ##
##      but WITHOUT ANY WARRANTY; without even the implied warranty of    ##
##      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     ##
##      Agreement.html for more details.                                  ##
##                                                                        ##
##      You should have received a copy of the Agreement.html as well as  ##
##      a copy of License.html with this program, if not, send a request  ##
##      to the below mentioned author(s).                                 ##
##                                                                        ##
##                         CoreUnix.com <srikanth@coreunix.com>           ##
##                                <http://www.coreunix.com/license.html>  ##
##                                                                        ##
######################## end license & copyright header ####################

use strict;
use CGI qw/:standard escapeHTML/;
use CGI::Carp qw/fatalsToBrowser/;
use Fcntl qw/:flock/;
use DBI;
$|++;


############################# Config Start
my $EXEPROG = 'getcsrpasswd.pl';
my $TITLE = 'Customer Tracking System';
my $COMPANY = 'Customer Tracking System';
my $TOMAIL = 'srikanth@coreunix.com';
my $SENTFROM = 'submit@coreunix.com';
my $MAIL_PRG = './custmail.prl';
my $ADM_PASS = './password.tech';
my $FORGOT_PASS = '../csrpasswd.html';
my $OR_SUMTOP = '../cus_top.html';
my $OR_SUMBOT = '../cus_foot.html';
my $WEB_URL = 'http://www.coreunix.com/custom';
my $URLREDIRECT = $WEB_URL . '/index.html';
my $DEBUG = 0;
############################# Config End

# Different actions of our page
if( (param('exit') eq 'Exit') || (param('exit') eq '   Exit   ') ) {
		print redirect($URLREDIRECT);
} elsif( param('action') eq 'getpasswd' ) {
	get_passwd();
} elsif( param('action') eq 'sendpasswd' ) {
	send_passwd();
} elsif( param('action') eq 'exit' ) {
	do_exit();
} else {
	get_passwd();
}

################## Sub Routines Start From HERE #################################

#--------------------------------------------------------------
sub print_top {
	# This prints out the @lines as a web page.
#--------------------------------------------------------------
	my @data;

	open( FILE, "< $OR_SUMTOP") or die "Can't open $OR_SUMTOP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
}

#--------------------------------------------------------------
sub print_form {
	# This prints out the @lines as a web page.
#--------------------------------------------------------------
	my @data;

	# Send our collected output to the user and end our HTML
	my  $lines = shift;
	print join("\n", @$lines);

	# Print footer and end page
	open( FILE, "< $OR_SUMBOT") or die "Can't open $OR_SUMBOT: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	foreach  ( @data ) {
		print;
	}
	print end_html;

	return ();
}

#--------------------------------------------------------------
sub do_exit {
	# When Exit button is pressed any necessary tasks before
	# exit can be placed here.
#--------------------------------------------------------------
	return();
}

#--------------------------------------------------------------
sub get_passwd {
	# This is used to Get the Customer Request Submit Form.
#--------------------------------------------------------------
	my  @lines;

	# Overwrite our current action so that we save this message
	param('action', 'sendpasswd');

	open( FILE, "<$FORGOT_PASS") or die "Can't open $FORGOT_PASS: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@lines = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	push(@lines, hidden('action'));
	push(@lines,qq!</form>!);
	print_form(\@lines);
	return ();
}

#--------------------------------------------------------------
sub send_passwd {
	# This is displayed after the Customer Submits his Request.
#--------------------------------------------------------------
	# Overwrite our current action so that we save this message
	my $uemail = param('uemail');
	my @lines;
	my ($cus_userid, $usr_passwd);

	open(FILE, $ADM_PASS) or die "Cannot open file $ADM_PASS: $!\n";
	flock(FILE, LOCK_SH); # Exclusive lock for reading
	while ( <FILE> ) {
		my ($user, $passdat) = split;
		if( $user eq $uemail ){
			$cus_userid = $user;
			$usr_passwd = $passdat;
			last;
		} 
	}
	flock(FILE, LOCK_UN);
	close FILE;


	# Start our HTML output
	print header;
	print start_html(-title=>"$TITLE", -bgcolor=>'white');
	print_top();
	print qq!<HR SIZE="1" NOSHADE>!;
	if( $usr_passwd ){
		push(@lines,
			qq!<BR><BR><B><div align="center">Your User information has been mailed!,
			qq! to $uemail.</div></B><BR><BR><BR><BR><BR><BR>!);
	} else {
		push(@lines,
			qq/<BR><BR><B><div align="center">Sorry!!! $uemail does not exist in our database/,
			qq! please go back and try again.</div></B><BR><BR><BR><BR><BR><BR>!);
	}
		
	print_form(\@lines);

	# Summary with Request ID added
	my $summary = "Your User Login Information at $COMPANY";

	# Message to Customer
	my $rcpt_message .= "Your login and password information is given below\n";
	$rcpt_message .= "Username:$cus_userid\nPassword:$usr_passwd\n";
	$rcpt_message .= " \n\n";
	$rcpt_message =~ s/[\047]/:QUOTE:/g;		# for handling (') on command line

	# Send mail user with to:$email from:$tech_email subject:$summary  Message:$information
	if( $usr_passwd ){
		system("$MAIL_PRG '$uemail' '$SENTFROM' '$summary' '$rcpt_message' &");
	}

	return ();
}

############################################ THE END  ##########################################
