#!/usr/bin/perl -w
############################################################################
##                                                                        ##
##	A Product of CoreUnix.com, Form Submission for CTS1.1             ##
##                                                                        ##
##                                                                        ##
########################## license & copyright header ######################
##                                                                        ##
##    This program has been tested to work both as a CGI script. 	  ##
##                                                                        ##
##                                                                        ##
##                    Copyright (c) 2003 by Sri Penumetcha                ##
##                                                                        ##
##      This program is proprietary software; it is intended only for     ##
##      the  customer's internal use. It is the responsibility of the     ##
##      customer to see to it that it is not used to any illegal          ##
##      cause.  The author has no responsibility what so ever to any      ##
##      damage to property or legal laws caused by this software once     ##
##      it has been out of the authors ownership.                         ##
##                                                                        ##
##      This program is developed in the hope that it will be useful,     ##
##      but WITHOUT ANY WARRANTY; without even the implied warranty of    ##
##      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     ##
##      Agreement.html for more details.                                  ##
##                                                                        ##
##      You should have received a copy of the Agreement.html as well as  ##
##      a copy of License.html with this program, if not, send a request  ##
##      to the below mentioned author(s).                                 ##
##                                                                        ##
##                         CoreUnix.com <srikanth@coreunix.com>           ##
##                                <http://www.coreunix.com/license.html>  ##
##                                                                        ##
######################## end license & copyright header ####################
use strict;
use CGI qw/ :standard escapeHTML/;
use CGI::Carp qw(fatalsToBrowser);
use DBI;
use Fcntl qw/:flock/;
$|++;

##########Config Start
my $TITLE = 'Customer Tracking System';
my $CNT_FILE = './usercnt.fl';
my $MAIL_PRG = './custmail.prl';
my $OR_SUMTOP = '../cus_top.html';
my $OR_SUMBOT = '../cus_foot.html';
my $SIGNUP = '../signup.html';
my $WEB_URL = 'http://www.coreunix.com/custom';
my $URLREDIRECT = $WEB_URL . '/cgi-bin/pl_order.pl';
my $USRS_PER_DAY = '2000';
my $TO_MUSR = 'srikanth@coreunix.com';
my $FROM_MUSR = 'submit@coreunix.com';
use constant DB => 'dbi:Pg:dbname=CUSCTS';
use constant DBAUTH => 'apache:';
use constant SECRET => 'modperl reigns';
use constant MAX_TRIES => 10;
our ($DBH, $DB_TABLE, $ID_LENGTH);
$ID_LENGTH  =  8;               #length of the session ID.
$DB_TABLE  =  'custrack';        #length of the session ID.
my $DEBUG = 0;

#use lib "/home1/coreunix/www/root/custom/cgi-bin";
use SESS;
##########Config End

# Open the database
$DBH = DBI->connect(DB, split(':',DBAUTH,2), {PrintError=>0})
        || die "Couldn't open database: ", $DBI::errstr;

# fetch or generate  the session id
my ($session_id, $note) = get_session_id();

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After get_session_id with session_id and note: $session_id--$note\n";
        close(DBUG);
}

# retrieve the state
my $state = get_state($session_id) unless param('clear');

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After get_state with session_id and state: $session_id--$state\n";
        close(DBUG);
}

# reinitialize if we need to
$state  = initialize($state) if !$state->{session_id} or param('restart');

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "After initialize with state: $state\n";
        close(DBUG);
}

my $get = new CGI;

# Check Action
if( param('action') =~ /Submit/ ) {
	if( !param('login') || !param('pw1') || !param('pw2') || !param('cemail') ){
		form_redo(" Please GO BACK and fill in the required fields marked with *");
	} else {
		submitForm($get, $session_id);
	}
} elsif ( param('action') =~ /Redo/ ) {
	print_form($get);
} else {
	 print_form($get);
}


####################################################

#--------------------------------------------------------------
sub submitForm {
	# Sumbit details to database and email.
#--------------------------------------------------------------
	my ($get, $id) = @_;
	$get->import_names('C');

	my $pw2 = param('pw2');
	
#	------------  Check for number of users created today ----------------
	my $cntval;
	open(CFILE, $CNT_FILE) or die "Cannot open $CNT_FILE: $!:\n";
	flock(CFILE, LOCK_SH); # shared lock
	while(<CFILE>) {
	  if( /[0-9]*/ ){ $cntval = s/$_/[0-9]*/; }
	  if( $cntval >= $USRS_PER_DAY ) {
		print h2('<font color=red>Sorry!!! E-Mail server is being backed up.
				 Please log back in tomorrow(After 24:00hrs EST) to create 
				your email accounts again. Thank You.</font>');
		flock(CFILE, LOCK_UN);
		close CFILE;

#		-----  Mail Admin that user login limit is met ----------------
		my $summary = "$USRS_PER_DAY users registered";
		my $rcpt_message = "The total limit per day has been met\n";
		system("$MAIL_PRG '$TO_MUSR' '$FROM_MUSR' '$summary' '$rcpt_message' &");
	  }
	}
	flock(CFILE, LOCK_UN);
	close CFILE;
			
#	------------  Check user data entered syntax ----------------
	if( !($C::login =~ /^[a-z|A-Z]+[a-z|A-Z|0-9|_]*/) ) {
		print start_html(-title=>$TITLE);
		print_top();
#		print h1("-".$login."-" );
			print h2('<font color=red>Sorry!!! Please go <font color=black> Back </font>
			 and make sure the login starts with a letter character followed by letter(a-z), 
			number(0-9) or underscore(_).</font>');
		print_bot();
		print end_html;
		return();
	} elsif ( $C::pw1 ne $pw2 ) {
		print start_html(-title=>$TITLE);
		print_top();
#		print h1("-".$pw1."-" . $pw2 ."-" );
			print h2('<font color=red>Sorry!!! Please go <font color=black> Back </font>
			and make sure the retyped password matches the former.</font>');
		print_bot();
		print end_html;
		return();
	} else {
		# Everything Good, Go On.
	}

#	------------  Check if user or email ID already exists in database ----------------
	# Retrieve the contents of this message
	my $sth = $DBH->prepare("SELECT * FROM $DB_TABLE WHERE usr_passwd is NOT NULL")
			 or die "ERROR: Invalid SQL in do_update(): $!";
	$sth->execute;

if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In submitForm Clogin : $C::login--\n";
        close(DBUG);
}
	while( my $cusref = $sth->fetchrow_hashref) {
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "In submitForm cus_userid: $cusref->{cus_userid}--\n";
        close(DBUG);
}
	  if( $C::login eq $cusref->{cus_userid} ){
		print header;
		print_top();
		print h2('<font color=red>Sorry!!! <font color=black> Your user ID:</font> has
		 already been taken, please go <font color=black> Back </font> and try a
		 different one.<BR> Thank You.</font><BR><BR><BR><BR><BR><BR><BR><BR><BR>');
	  	print_bot();
		print end_html;
	  	return();
	  } elsif( $C::cemail eq $cusref->{cus_email} ){
		print header;
		print_top();
		print h2('<font color=red>Sorry!!! <font color=black> Your Email ID:</font> has
		 already been taken, please go <font color=black> Back </font> and try a
		 different one.<BR> Thank You.</font><BR><BR><BR><BR><BR><BR><BR><BR><BR>');
	  	print_bot();
		print end_html;
	  	return();
	  }
	
	}

#	------------  if not add user count to count file ----------------
	open(FILE, ">$CNT_FILE") or die "Cannot open $CNT_FILE: $!:\n";
	flock(FILE, LOCK_EX); # Exclusive lock for writing
	$cntval++;
	print FILE "$cntval\n";
	flock(FILE, LOCK_UN);
	close FILE;

#	------ Save the Registraion Infomation to custrack database state ------
	$DBH->do("INSERT INTO $DB_TABLE(created, cus_name, cus_email, ".
               "day_phone, eve_phone, zcode, sex, usr_passwd, cus_userid) VALUES ".
               "('now', '$C::contfld', '$C::cemail', '$C::day_phone',".
               " '$C::eve_phone', '$C::zcode', '$C::sex', '$C::pw1', '$C::login')") or die "ERROR in saving message: $!";

#	------------  Mail user username and password ----------------
	my $summary = "Your $TITLE Account Information";
	my $rcpt_message = "Username:$C::login \nPassword:$C::pw1 \nYou will need to keep this" .
			" information every time you need to update your request information\n";
	system("$MAIL_PRG '$C::cemail' '$FROM_MUSR' '$summary' '$rcpt_message' &");

#	------------  Salute the  user ----------------
if( $DEBUG ) {
        open( DBUG, ">>hangdb.log") || die "Can't open log file: $!\n";
        print DBUG "Before URL redirecting: $URLREDIRECT--$id\n";
        close(DBUG);
}
        print redirect("$URLREDIRECT" . "?sessionid=$id");
}
	
#--------------------------------------------------------------
sub print_form { # Main E-Mail registration form
	# Show the User sign up page.
#--------------------------------------------------------------
	my $sessionid = param('sessionid');
	my @data;

	print header;
	print start_html(	-bgcolor=>'white',
			-title=>$TITLE,
			-onLoad => 'if (document.gf) document.gf.login.focus()');
	print_top();
	print start_form( -name=> 'gf');
	# Starting Form
	open( FILE, "< $SIGNUP") or die "Can't open $SIGNUP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;

	# Print out HTML FORM
	foreach  ( @data ) {
		print;
	}
	print hidden( -name=>'sessionid', -value=>"$sessionid");
	print end_form;
	print_bot();
	print end_html;
}

#--------------------------------------------------------------
sub form_redo {
#--------------------------------------------------------------
	my ($errMsg) = @_;
	my @data;

	print header;
	print_top();
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<CENTER><STRONG><font color=#FF0033>SORRY !!! " .
		"$errMsg</font></STRONG></CENTER>\n";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print "<BR>";
	print_bot();
	print end_html;

}

#--------------------------------------------------------------
sub print_top {
	# This prints the top head section
#--------------------------------------------------------------
	my @data;
	open( FILE, "< $OR_SUMTOP") or die "Can't open $OR_SUMTOP: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;
	foreach  ( @data ) {
		print;
	}
	return;
}

#--------------------------------------------------------------
sub print_bot {
	# This prints the bottom foot section
#--------------------------------------------------------------
	my @data;
	open( FILE, "< $OR_SUMBOT") or die "Can't open $OR_SUMBOT: $!\n";
	flock(FILE, LOCK_SH);	# Locked in shared mode for reading
	@data = (<FILE>);
	flock(FILE, LOCK_UN); 	# Unlock the file
	close FILE;
	foreach  ( @data ) {
		print;
	}
}
