<?php
/**
* Show information about a given user
* This file lists all stored information
*   into a table for administrative viewing.
* @author Nick Korbel <lqqkout13@users.sourceforge.net>
* @version 11-08-03
* @package phpScheduleIt
*/
/**
* User class
*/
require_once('lib/User.class.php');
/**
* Template class
*/
require_once('lib/Template.class.php');
/**
* Templates for output
*/
require_once('templates/userinfo.template.php');
/**
* UserInfoDB class
*/
require_once('lib/db/UserInfoDB.class.php');

// Make sure this is the administrator
if (!Auth::isAdmin()) {
    CmnFns::do_error_box('This page is only available to the administrator.');
}

$user = new User($_GET['user']);

$t = new Template('User Info: ' . $user->get_name());

$t->printHTMLHeader();		// Print HTML header


if (!$user->is_valid()) {	// Make sure member ID is valid
    CmnFns::do_error_box('Sorry, memberid: ' . $user->get_id() . 'is not available.');
}

$db = new UserInfoDB();

$prev = $db->get_prev_userid($user);	// Prev memberid
$next = $db->get_next_userid($user);	// Next memberid

$t->startMain();	// Start main table

printUI($user);		// Print user info

printLinks($prev, $next);	// Print links
 
$t->endMain();		// End main table

$t->printHTMLFooter();		// Print HTML footer
?>